<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER.tsx.ftl
</#ibizinclude>

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getDatas(): any[] {
        return [this.selectData];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getData(): any {
        return this.selectData;
    }

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 初始化完成
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public inited: boolean = false;

    /**
     * 选中数据
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public selectData: any = {};

    /**
     * Api路径
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public url: string = '${app.getPKGCodeName()?lower_case}/ctrl/${ctrl.codeName?lower_case}treeview';

    /**
     * 父数据
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public parentData: any = {};

    /**
     * 过滤属性
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public srfnodefilter: string = '';

    /**
     * 默认输出图标
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public isOutputIconDefault: boolean = ${ctrl.isOutputIconDefault()?c};

    /**
     * 树数据
     *
     * @type {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Provide()
    public nodes: any[] = [];

    /**
     * 数据展开主键
     *
     * @type {string[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Provide()
    public expandedKeys: string[] = [];

    /**
     * 选中数据变更事件
     *
     * @private
     * @param {*} data
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private selectionChange(data: any, node: any) {
        this.selectData = {};
        if (data.disableselect) {
            node.isCurrent = false;
            this.$emit('selectionchange', []);
            return;
        }
        Object.assign(this.selectData, data);
        this.$emit('selectionchange', [this.selectData]);
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public created() {
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('load', action)) {
                    if (data && data.srfparentdata) {
                        Object.assign(this.parentData, data.srfparentdata);
                    }
                    this.inited = false;
                    this.$nextTick(() => {
                        this.inited = true;
                    });
                }
                if (Object.is('filter', action)) {
                    this.srfnodefilter  = data.srfnodefilter;
                    this.inited = false;
                    this.$nextTick(() => {
                        this.inited = true;
                    });
                }
                if (Object.is('refresh_parent', action)) {
                    this.refresh_parent();
                }
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public destroyed() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 刷新数据
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public refresh_all(): void {
        this.inited = false;
        this.$nextTick(() => {
            this.inited = true;
        });
    }

    /**
     * 刷新父节点
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public refresh_parent(): void {
        if (Object.keys(this.selectData).length === 0) {
            return;
        }
        const tree: any = this.$refs.treeexpbar_tree;
        const node: any = tree.getNode(this.selectData.id);
        if (!node || !node.parent) {
            return;
        }
        const { parent: _parent } = node;
        const id: string = _parent.key ? _parent.key : '#';
        const param: any = { srfnodeid: id };
        Object.assign(param, this.parentData);
        this.refresh_node(param, true);
    }

    /**
     * 数据加载
     *
     * @param {*} node
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public load(node: any = {}, resolve?: any) {
        if(node.data && node.data.children) {
            resolve(node.data.children);
            return;
        }
        const param: any = {
            srfnodeid: node.data && node.data.id ? node.data.id : '#',
            srfnodefilter: this.srfnodefilter,
        };
        Object.assign(param, this.parentData);
        const get: Promise<any> = this.$http.get(this.url + '/getnodes', param, this.showBusyIndicator);
        get.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: response.info });
                resolve([]);
                return;
            }
            const _items = [...response.data];
            this.formatExpanded(_items);
            if (!node.level || node.level === 0) {
                this.nodes = [..._items];
            } 

            resolve([..._items]);
            this.setDefaultSelection(_items);
            this.$emit('load', _items);
        }).catch((response: any) => {
            resolve([]);
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: '错误', desc: response.info });
        });
    }

    /**
     * 刷新功能
     *
     * @param {any[]} args
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public refresh(args: any[]): void {
        if (Object.keys(this.selectData).length === 0) {
            return;
        }
        const id: string = this.selectData.id;
        const param: any = { srfnodeid: id };
        Object.assign(param, this.parentData);
        this.refresh_node(param, false);
    }

    /**
     * 刷新节点
     *
     * @private
     * @param {*} [arg={}]
     * @param {boolean} parentnode
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private refresh_node(arg: any = {}, parentnode: boolean): void {
        const { srfnodeid: id } = arg;
        const get: Promise<any> = this.$http.get(this.url + '/getnodes', arg, this.showBusyIndicator);
        get.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: response.info });
                return;
            }
            const _items = [...response.data];
            this.formatExpanded(_items);
            const tree: any = this.$refs.${ctrl.name};
            tree.updateKeyChildren(id, _items);
            if (parentnode) {
                this.selectData = {};
            }
            this.setDefaultSelection(_items);
        }).catch((response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: '错误', desc: response.info });
        });
    }

    /**
     * 格式化数据
     *
     * @private
     * @param {any[]} items
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private formatExpanded(items: any[]): any[] {
        const data: any[] = [];
        items.forEach((item) => {
            if (item.expanded || (item.children && item.children.length > 0)) {
                this.expandedKeys.push(item.id);
            }
        });
        return data;
    }

    /**
     * 设置默认选中
     *
     * @param {any[]} items
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public setDefaultSelection(items: any[]): void {
        const index = items.findIndex((item: any) => item.selected);
        if(index === -1) {
            return ;
        }
        const data = items[index];
        this.setTreeNodeHighLight(data);
        this.$emit('selectionchange', [this.selectData]);
    } 

    /**
     * 设置选中项
     *
     * @param {*} data
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public setTreeNodeHighLight(data: any): void {
        this.selectData = {};
        Object.assign(this.selectData, data);
        const tree: any = this.$refs.${ctrl.name};
        tree.setCurrentKey(data.id);
    }

    /**
     * 绘制右击菜单
     *
     * @param {*} node
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public renderContextMenu(node: any) {
        let content;
        if (node && node.data) {
            const data: any = node.data;
            this.selectData = { ...data };
            const tags: string[] = data.id.split(';');
<#if ctrl.getPSControls()??>
<#list ctrl.getPSControls() as childCtrl>
<#if childCtrl.getControlType() == "CONTEXTMENU">
            if (tags[0] === "${childCtrl.getOwner().getNodeType()}") {
                content = this.renderContextMenu${srfclassname(childCtrl.getOwner().getNodeType()?lower_case)}();
            }
</#if>
</#list>
</#if>
        }
        return content;
    }
<#if ctrl.getPSControls()??>
<#list ctrl.getPSControls() as childCtrl>
<#if childCtrl.getControlType() == "CONTEXTMENU">

    /**
     * 绘制${childCtrl.getOwner().getNodeType()}类型右键菜单
     *
     * @param {*} node
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private renderContextMenu${srfclassname(childCtrl.getOwner().getNodeType()?lower_case)}() {
        return (
<@ibizindent blank=12>
${P.getCtrlCode(childCtrl, 'CONTROL.html').code}
</@ibizindent>
        );
    }
</#if>
</#list>
</#if>

    /**
     * 执行默认界面行为
     *
     * @param {*} node
     * @memberof AppView
     */
    public doDefaultAction(node: any) {
        if (node && node.data) {
            const data: any = node.data;
            const tags: string[] = data.id.split(';');
<#if ctrl.getPSDETreeNodes()??>
<#list ctrl.getPSDETreeNodes() as node>
<#if node.getPSDEContextMenu()?? && node.getDefaultPSUIAction()??>
<#assign contextMenu = node.getPSDEContextMenu()/>
            if (tags[0] === "${contextMenu.getOwner().getNodeType()}") {
                this.${contextMenu.name}_click({tag: '${node.getDefaultPSUIAction().name}'});
            }
</#if>
</#list>
</#if>
        }
    }


    /**
     * 绘制图标
     *
     * @param {*} h
     * @param {*} data
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public renderIcon(h: any, data: any) {
        return (
            <span class='icon'>
                {
                    data.iconcls && !Object.is(data.iconcls, '') ?
                        <i class={data.iconcls} ></i> :
                        data.icon && !Object.is(data.icon, '') ?
                            <img src={data.icon} /> :
                            this.isOutputIconDefault ?
                                <icon type="ios-paper-outline"></icon> : ''
                }
                &nbsp;
            </span>
        );
    }


    /**
     * 绘制树内容
     *
     * @protected
     * @param {*} h
     * @param {*} context
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected renderTreeItem(h: any, context: any) {
        const { node, data } = context;
        return (
            <context-menu contextMenuStyle={{ width: '100%' }} data={node} renderContent={this.renderContextMenu}>
                <tooltip transfer style="width: 100%;" max-width={2000} placement="right">
                    <div class='tree-node' on-dblclick={() => this.doDefaultAction(node)}>
                        {this.renderIcon(h, data)}
                        <span class='text'>
                            {
                                data.html ? <span domProps={{innerHTML: data.html}}></span> : data.text
                            }
                        </span>
                    </div>
                    <template slot="content">
                        {
                            data.html ? <span domProps={{innerHTML: data.html}}></span> : data.text
                        }
                    </template>
                </tooltip>
            </context-menu>
        );
    }

    /**
     * 绘制内容
     *
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public render() {
        return (
            <context-menu-container class='design-tree-container'>
                {
                    this.inited ?
                        this.$createElement('el-tree', {
                            ref: '${ctrl.name}',
                            class: {
                                'design-tree': true,
                            },
                            props: {
                                'node-key': 'id',
                                lazy: true,
                                'default-expanded-keys': this.expandedKeys,
                                props: {
                                    label: 'text',
                                    isLeaf: 'leaf'
                                },
                                load: (node: any, resolve: any) => this.load(node, resolve),
                                'highlight-current': true,
                                'expand-on-click-node': false,
                                'render-content': (h: any, context: any) => this.renderTreeItem(h, context),
                            },
                            on: {
                                'current-change': (data: any, node: any) => this.selectionChange(data, node),
                            }
                        })
                        : ''
                }
            </context-menu-container>
        );
    }

}